Public Class Form2
    Inherits System.Windows.Forms.Form

    'form-level scope declarations
    Dim myPath As String = "c:\"
    Dim myDirName As String
    Dim myFileName As String

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
    End Sub

    'Form overrides dispose to clean up the component list.
    Public Overloads Overrides Sub Dispose()
        MyBase.Dispose()
        If Not (components Is Nothing) Then
            components.Dispose()
        End If
    End Sub
    Private WithEvents label1 As System.Windows.Forms.Label
    Private WithEvents label2 As System.Windows.Forms.Label
    Private WithEvents labelDirectoryInfo As System.Windows.Forms.Label
    Private WithEvents listBoxFiles As System.Windows.Forms.ListBox
    Private WithEvents labelFileInfo As System.Windows.Forms.Label
    Private WithEvents listBoxDirectories As System.Windows.Forms.ListBox
    Private WithEvents buttonClose As System.Windows.Forms.Button

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.labelFileInfo = New System.Windows.Forms.Label()
        Me.listBoxFiles = New System.Windows.Forms.ListBox()
        Me.labelDirectoryInfo = New System.Windows.Forms.Label()
        Me.listBoxDirectories = New System.Windows.Forms.ListBox()
        Me.buttonClose = New System.Windows.Forms.Button()
        Me.label1 = New System.Windows.Forms.Label()
        Me.label2 = New System.Windows.Forms.Label()
        Me.labelFileInfo.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.labelFileInfo.Location = New System.Drawing.Point(248, 216)
        Me.labelFileInfo.Size = New System.Drawing.Size(200, 160)
        Me.labelFileInfo.TabIndex = 4
        Me.labelFileInfo.Text = "label3"
        Me.listBoxFiles.Location = New System.Drawing.Point(8, 216)
        Me.listBoxFiles.Size = New System.Drawing.Size(232, 160)
        Me.listBoxFiles.TabIndex = 1
        Me.labelDirectoryInfo.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.labelDirectoryInfo.Location = New System.Drawing.Point(248, 24)
        Me.labelDirectoryInfo.Size = New System.Drawing.Size(200, 160)
        Me.labelDirectoryInfo.TabIndex = 4
        Me.labelDirectoryInfo.Text = "label3"
        Me.listBoxDirectories.Location = New System.Drawing.Point(8, 24)
        Me.listBoxDirectories.Size = New System.Drawing.Size(232, 160)
        Me.listBoxDirectories.TabIndex = 0
        Me.buttonClose.Location = New System.Drawing.Point(376, 384)
        Me.buttonClose.TabIndex = 5
        Me.buttonClose.Text = "Close"
        Me.label1.Location = New System.Drawing.Point(8, 8)
        Me.label1.TabIndex = 2
        Me.label1.Text = "Directories"
        Me.label2.Location = New System.Drawing.Point(8, 200)
        Me.label2.TabIndex = 3
        Me.label2.Text = "Files"
        Me.AcceptButton = Me.buttonClose
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.ClientSize = New System.Drawing.Size(453, 410)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.buttonClose, _
            Me.labelFileInfo, Me.listBoxFiles, Me.listBoxDirectories, _
            Me.labelDirectoryInfo, Me.label2, Me.label1})
        Me.Text = "Directory And Files"

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles MyBase.Load

        'purpose:   load the form, set the control values

        'local scope
        Dim myDirectories() As System.IO.DirectoryInfo
        Dim i As Integer

        'create a new directory object pointed at c:
        Dim myDirectory As New System.IO.DirectoryInfo(path:=myPath)

        'return the sub directories of c: from the global directory object
        myDirectories = myDirectory.GetDirectories()

        'loop through the directories and add them to the list box
        For i = 0 To UBound(myDirectories) - 1

            'add the directory name to the list
            listBoxDirectories().Items.Add(myDirectories(i).Name)

        Next

        'select the first directory in the list
        '  note: this will trigger the events that fill the label control
        '        and the files list box and its label control
        listBoxDirectories().SelectedIndex = 0

    End Sub

    Private Sub buttonClose_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles buttonClose.Click

        'purpose:   end the application

        'close the form
        Me.Close()

    End Sub

    Private Sub listBoxDirectories_SelectedIndexChanged(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles listBoxDirectories.SelectedIndexChanged

        'purpose: synchronize the files list box with the selected directory
        '         and display the selected directory's information

        'local scope
        Dim myDirectory As System.IO.DirectoryInfo
        Dim dirInfo As String
        Dim myFiles() As System.IO.FileInfo
        Dim i As Integer

        'clear the listbox of its current contents
        listBoxFiles().Items.Clear()

        'get a directory info object based on the user's selection
        myDirName = listBoxDirectories().SelectedItem.ToString & "\"
        myDirectory = New System.IO.DirectoryInfo( _
            path:=(myPath & myDirName))

        'set the dir info
        dirInfo = dirInfo & "Path: " & myDirectory.FullName & vbCrLf
        dirInfo = dirInfo & "Attributes: " & myDirectory.Attributes.ToString & vbCrLf
        labelDirectoryInfo().Text = dirInfo

        'get the files in the directory
        myFiles = myDirectory.GetFiles()

        'check for files
        If UBound(myFiles) >= 0 Then

            'loop through the files array and add to the listbox
            For i = 0 To UBound(myFiles) - 1
                listBoxFiles().Items.Add(myFiles(i).Name)
            Next

            'select the file in the list, this will trigger the event to change
            '   the file info label control
            listBoxFiles().SelectedIndex = 0

        End If

    End Sub

    Private Sub listBoxFiles_SelectedIndexChanged(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles listBoxFiles.SelectedIndexChanged

        'purpose:   change the contents of the file properties label

        'local scope
        Dim myFile As System.IO.FileInfo
        Dim fileInfo As String

        'set the file name
        myFileName = listBoxFiles().SelectedItem.ToString

        'create a new file object
        myFile = New System.IO.FileInfo(fileName:=myPath & myDirName & myFileName)

        'set the file info to display
        fileInfo = fileInfo & "Directory: " & myFile.DirectoryName & vbCrLf
        fileInfo = fileInfo & "Created Time: " & myFile.CreationTime & vbCrLf
        fileInfo = fileInfo & "Size: " & myFile.Length & vbCrLf
        fileInfo = fileInfo & "Last Accessed: " & myFile.LastAccessTime & vbCrLf
        fileInfo = fileInfo & "Attributes: " & myFile.Attributes.ToString & vbCrLf

        'set the label to the file's info
        labelFileInfo().Text = fileInfo

    End Sub

#End Region

End Class
