Imports System.IO

Module Module1

    Sub Main()

        'purpose:   demonstrate code that does the following:
        '           1. creates a file 
        '           3. moves the file to a different directory
        '           4. copies the file to another directory
        '           5. deletes the file

        'local scope
        Dim myFileStream As FileStream
        Dim myFile As FileInfo
        Dim myCopiedFile As FileInfo

        'check if file exists, if so delete it
        If File.Exists(path:="c:\newFile.txt") Then
            File.Delete(path:="c:\newFile.txt")
        End If

        'create a new file using, set = to file stream object
        myFileStream = File.Create(path:="c:\newFile.txt")

        'close the file stream object
        myFileStream.Close()

        'get the newly created file
        myFile = New FileInfo(fileName:="c:\newFile.txt")

        'check if move to file exists, if so delete it
        If File.Exists(path:="c:\moveFile.txt") Then
            File.Delete(path:="c:\moveFile.txt")
        End If

        'move the file
        myFile.MoveTo(destFileName:="c:\moveFile.txt")

        'check to see if directory exists, else create it
        If Not System.IO.Directory.Exists(path:="C:\new directory 1") Then
            System.IO.Directory.CreateDirectory( _
                path:="C:\new directory 1")
        End If

        'copy the file back to the directory
        'overwrite an existing file if need be
        myCopiedFile = myFile.CopyTo( _
            destFileName:="C:\new directory 1\copyFile.txt", _
            overwrite:=True)

        'wait for the user to stop the console application
        'this allows you to view the directories and the results
        Console.WriteLine("Enter 's' to stop the application.")

        'loop until users presses s key
        Do While Console.ReadLine <> "s" : Loop

        'delete the files
        myFile.Delete()
        myCopiedFile.Delete()

    End Sub

End Module