Imports System.IO

Module Module1

    Sub Main()

        'Call directory()
        Call watchDirectory(watchPath:="c:\watch")

    End Sub

    Sub watchDirectory(ByVal watchPath As String)

        'purpose:   watch a directory for changes to files

        'local scope
        Dim myWatcher As FileSystemWatcher
        Dim stopValue As String

        'check if directory exits, no = create
        If Not Directory.Exists(path:=watchPath) Then
            Directory.CreateDirectory(path:=watchPath)
        End If

        'instantiate a new system watcher object
        myWatcher = New FileSystemWatcher()

        'set the path of directory to watch
        myWatcher.Path = watchPath

        'tell the watcher object to watch only for text files
        myWatcher.Filter = "*.txt"

        'tell the watcher the type of changes to watch for
        myWatcher.NotifyFilter = IO.NotifyFilters.DirectoryName _
            Or IO.NotifyFilters.LastAccess _
            Or IO.NotifyFilters.LastWrite _
            Or IO.NotifyFilters.FileName

        'intercept the watcher events
        AddHandler myWatcher.Changed, AddressOf watcher_OnChange
        AddHandler myWatcher.Deleted, AddressOf watcher_OnChange
        AddHandler myWatcher.Created, AddressOf watcher_OnChange
        AddHandler myWatcher.Renamed, AddressOf watcher_OnRename

        'tell the watcher to start watching
        myWatcher.EnableRaisingEvents = True

        'tell the user that watching is on
        Console.WriteLine("Watching " & watchPath & "...")

        'wait for the user to stop the console application
        Console.WriteLine("Press 's' to stop the application.")

        'loop until users presses s key
        Do While Console.ReadLine <> "s" : Loop

    End Sub

    Sub watcher_OnChange(ByVal source As Object, _
        ByVal e As IO.FileSystemEventArgs)

        'purpose:   respond to the changed nofiy event 
        '           (created, changed, deleted)

        'indicate that a file is changed, created, or deleted
        Console.WriteLine("File: " & e.FullPath & " " & e.ChangeType)

    End Sub

    Sub watcher_OnRename(ByVal source As Object, _
        ByVal e As IO.RenamedEventArgs)

        'purpose:   respond to the renamed watcher notify event

        'tell the unser the file that was renamed
        Console.WriteLine("File: {0} renamed to {1}", e.OldFullPath, _
            e.FullPath)

    End Sub

End Module
