Public Class formSave
    Inherits System.Windows.Forms.Form

    'form-level scope declarations
    Dim myDirName As String

    'note:  issues
    '1. cannot save to the root directory
    '2. the return character not coming out right
    '3. files saved cannot be seen by the open
    '4. delete the file if exists??

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Public Overloads Overrides Sub Dispose()
        MyBase.Dispose()
        If Not (components Is Nothing) Then
            components.Dispose()
        End If
    End Sub
    Private WithEvents label1 As System.Windows.Forms.Label
    Private WithEvents buttonOk As System.Windows.Forms.Button
    Private WithEvents buttonCancel As System.Windows.Forms.Button
    Private WithEvents buttonUp As System.Windows.Forms.Button
    Private WithEvents label2 As System.Windows.Forms.Label
    Private WithEvents textBoxFileName As System.Windows.Forms.TextBox
    Private WithEvents listBoxDirectories As System.Windows.Forms.ListBox
    Private WithEvents labelSaveTo As System.Windows.Forms.Label

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.buttonOk = New System.Windows.Forms.Button()
        Me.buttonCancel = New System.Windows.Forms.Button()
        Me.buttonUp = New System.Windows.Forms.Button()
        Me.listBoxDirectories = New System.Windows.Forms.ListBox()
        Me.labelSaveTo = New System.Windows.Forms.Label()
        Me.label1 = New System.Windows.Forms.Label()
        Me.label2 = New System.Windows.Forms.Label()
        Me.textBoxFileName = New System.Windows.Forms.TextBox()
        Me.buttonOk.Location = New System.Drawing.Point(124, 220)
        Me.buttonOk.TabIndex = 1
        Me.buttonOk.Text = "OK"
        Me.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.buttonCancel.Location = New System.Drawing.Point(204, 220)
        Me.buttonCancel.TabIndex = 0
        Me.buttonCancel.Text = "Cancel"
        Me.buttonUp.Location = New System.Drawing.Point(256, 72)
        Me.buttonUp.Size = New System.Drawing.Size(24, 23)
        Me.buttonUp.TabIndex = 4
        Me.buttonUp.Text = "up"
        Me.listBoxDirectories.Location = New System.Drawing.Point(8, 72)
        Me.listBoxDirectories.Size = New System.Drawing.Size(244, 95)
        Me.listBoxDirectories.TabIndex = 3
        Me.labelSaveTo.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.labelSaveTo.Location = New System.Drawing.Point(8, 28)
        Me.labelSaveTo.Size = New System.Drawing.Size(272, 36)
        Me.labelSaveTo.TabIndex = 6
        Me.label1.Location = New System.Drawing.Point(8, 8)
        Me.label1.Size = New System.Drawing.Size(124, 23)
        Me.label1.TabIndex = 2
        Me.label1.Text = "Save to directory:"
        Me.label2.Location = New System.Drawing.Point(4, 172)
        Me.label2.TabIndex = 2
        Me.label2.Text = "File name:"
        Me.textBoxFileName.Location = New System.Drawing.Point(8, 192)
        Me.textBoxFileName.Size = New System.Drawing.Size(272, 20)
        Me.textBoxFileName.TabIndex = 5
        Me.AcceptButton = Me.buttonOk
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.CancelButton = Me.buttonCancel
        Me.ClientSize = New System.Drawing.Size(285, 250)
        Me.Controls.AddRange(New System.Windows.Forms.Control() _
            {Me.labelSaveTo, Me.textBoxFileName, Me.label2, Me.buttonUp, _
                Me.listBoxDirectories, Me.label1, Me.buttonOk, Me.buttonCancel})
        Me.Text = "Save Text File"

    End Sub

    Private Sub formSave_Load(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles MyBase.Load

        'purpose:   load the form

        'local scope

        'load the directory list box
        Call loadDirListBox()

    End Sub

    Private Sub loadDirListBox()

        'purpose:   load the list box control based on the current path
        '           note: this procedure is the same as the one in formOpen

        'local scope
        Dim myDirectory As System.IO.DirectoryInfo
        Dim myDirectories() As System.IO.DirectoryInfo
        Dim i As Integer

        'clear the directory list box
        listBoxDirectories().Items().Clear()

        'create a new directory object
        myDirectory = New System.IO.DirectoryInfo(path:=myPath)

        'return the sub directories from the global directory object
        myDirectories = myDirectory.GetDirectories()

        'loop through the directories and add them to the list box
        For i = 0 To UBound(myDirectories) - 1

            'add the directory name to the list
            listBoxDirectories().Items.Add(myDirectories(i).Name)

        Next

        'select the first directory in the list
        '  note: this will trigger the events that fill the label control
        '        and the files list box and its label control
        If listBoxDirectories().Items.Count > 0 Then
            listBoxDirectories().SelectedIndex = 0
        End If

    End Sub

    Private Sub listBoxDirectories_SelectedIndexChanged( _
        ByVal sender As System.Object, _
        ByVal e As System.EventArgs) _
        Handles listBoxDirectories.SelectedIndexChanged

        'purpose:   update the directory name when users select a directory

        'local scope

        'set the directory's name
        myDirName = listBoxDirectories().SelectedItem.ToString & "\"

        'reset the save to directory
        labelSaveTo().Text = myPath & myDirName

    End Sub

    Private Sub buttonUp_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles buttonUp.Click

        'purpose:   move back one directory
        '           note: this proc. is the same as formOpen

        'local scope
        Dim intPos As Integer

        'find the \ at the end of the path
        intPos = InStrRev(stringCheck:=Mid(myPath, 1, Len(myPath) - 1), _
            stringMatch:="\")

        If intPos = 0 Then
            'no more path info
            Beep()
        Else
            'trim the path back
            myPath = Mid(myPath, 1, intPos)
            Call loadDirListBox()
        End If

    End Sub

    Private Sub listBoxDirectories_DoubleClick(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles listBoxDirectories.DoubleClick

        'purpose:   manange the double-click event 
        '           which allows users to navigate down directories
        '           note: same as formOpen's

        'local scope

        'set the new global path
        myPath = myPath & myDirName

        'reset the selected directory to nothing
        myDirName = ""

        'update the list directory list box
        Call loadDirListBox()

    End Sub

    Private Sub buttonOk_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles buttonOk.Click

        'purpose:   user has indicated they would like to apply their selections

        'local scope
        Dim fileName As String

        'get the file name
        fileName = Trim(textBoxFileName().Text)

        'validate filename
        If fileName = "" Then

            'raise a message to the user
            MsgBox(prompt:="Please enter a file name.", _
                buttons:=MsgBoxStyle.Exclamation, title:="FontPad Save")

            'position cursor
            textBoxFileName().Focus()

        Else

            'check the file name's extension
            If Not fileName.EndsWith(".txt") Then
                fileName = fileName.Insert(fileName.Length, ".txt")
            End If

            'call save file method
            Call saveFile(fileName:=fileName)

            'close the form
            Me.Close()

        End If

    End Sub

    Private Sub saveFile(ByVal fileName As String)

        'purpose:   save the contents of the rtb to a file 

        'local scope
        Dim fileStream As IO.FileStream
        Dim streamWriter As IO.StreamWriter
        Dim filePath As String

        'set the full path of the file
        filePath = myPath & myDirName & fileName

        'check if the file already exists in the directory
        If IO.File.Exists(path:=filePath) Then

            'the file already exists, we cheat and delete it
            IO.File.Delete(path:=filePath)

        End If

        'create a new instance of the file stream object
        'note: if the file does not exist, the constructor will create it
        fileStream = New IO.FileStream(path:=filePath, _
            mode:=IO.FileMode.OpenOrCreate, access:=IO.FileAccess.Write)

        'create an instance of a character writer
        streamWriter = New IO.StreamWriter(stream:=fileStream)

        'set the file pointer to the end of the file
        streamWriter.BaseStream.Seek(offset:=0, origin:=IO.SeekOrigin.Begin)

        'write a line of text to the end of the file
        streamWriter.Write(value:=textContents)

        'apply the update to the file
        streamWriter.Flush()

        'close the stream writer
        streamWriter.Close()

        'close the file stream object
        fileStream.Close()

    End Sub

#End Region

End Class
